unit ObjectsEgForm;

interface

uses
  ObjectsEgCarClasses,
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls;

type
  TForm1 = class(TForm)
    btnDriveMorrisMinor: TButton;
    btnDrivePorsche911: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    btnDrivePorsche911_2: TButton;
    btnDriveMorrisMinor_2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnDriveMorrisMinorClick(Sender: TObject);
    procedure btnDrivePorsche911Click(Sender: TObject);
    procedure btnDriveACarClick(Sender: TObject);
  public
    Morris: TMorrisMinor;
    Porsche: TPorsche911;
    Cars: array[0..1] of TCar;
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  Morris := TMorrisMinor.Create;
  Morris.Parked := False;
  Porsche := TPorsche911.Create;
  Porsche.Parked := False;
  Cars[0] := Morris;
  Cars[1] := Porsche;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Morris);
  FreeAndNil(Porsche)
end;

procedure TForm1.btnDriveMorrisMinorClick(Sender: TObject);
begin
  Morris.Speed := Random(Morris.TopSpeed) + 1;
  Morris.Drive
end;

procedure TForm1.btnDrivePorsche911Click(Sender: TObject);
begin
  Porsche.Speed := Random(Porsche.TopSpeed) + 1;
  Porsche.Drive
end;

procedure TForm1.btnDriveACarClick(Sender: TObject);
var
  Idx: Integer;
  Car: TCar;
begin
  Idx := (Sender as TButton).Tag;
  Car := Cars[Idx];
  Car.Speed := Random(Car.TopSpeed) + 1;
  Car.Drive
end;

end.
